package com.uva.users.Model;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.Table;
import jakarta.persistence.Id;
import jakarta.persistence.NamedQueries;
import jakarta.persistence.NamedQuery;
import java.io.Serializable;

@Entity
@Table(name = "Vino")
@NamedQueries({
    @NamedQuery(
        name = "Vino.findByDenominacionOrdenadoNombreDesc",
        query = "SELECT V FROM Vino V WHERE V.denominacion = ?1 ORDER BY V.nombreComercial DESC"),
    @NamedQuery(
        name = "Vino.findByDenominacionYCategoria",
        query = "SELECT V FROM Vino V WHERE V.denominacion = ?1 AND V.categoria = ?2"
    )
})
public class Vino implements Serializable {
    @Id
    @GeneratedValue
    private Integer Id;
    @Column(name = "nombre_comercial")
    private String nombreComercial;
    private String denominacion;
    private String categoria;
    @Column(nullable = false)
    private Float precio;
    private Integer bodegaId;

    Vino() {
    }

    Vino(String nombre_comercial, String denominacion, String categoria, Float precio, Integer bodega) {
        this.nombreComercial = nombre_comercial;
        this.denominacion = denominacion;
        this.categoria = categoria;
        this.precio = precio;
        this.bodegaId = bodega;
    }

    // Getters y Setters
    public Integer getId() {
        return Id;
    }

    public void setId(Integer Id) {
        this.Id = Id;
    }

    public String getNombreComercial() {
        return nombreComercial;
    }

    public void setNombreComercial(String nombreComercial) {
        this.nombreComercial = nombreComercial;
    }

    public String getDenominacion() {
        return denominacion;
    }

    public void setDenominacion(String denominacion) {
        this.denominacion = denominacion;
    }

    public String getCategoria() {
        return categoria;
    }

    public void setCategoria(String categoria) {
        this.categoria = categoria;
    }

    public Float getPrecio() {
        return precio;
    }

    public void setPrecio(Float precio) {
        this.precio = precio;
    }

    public Integer getBodegaId() {
        return bodegaId;
    }

    public void setBodegaId(Integer bodegaId) {
        this.bodegaId = bodegaId;
    }
}